import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class deBoor extends Frame
{  public int Iter,Itermax; public double Err;
   public deBoor()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double[] setData(int N)
   { double [] Q= new double[N];
     for(int i=0;i<N; i++)  Q[i] =((double) i) * 0.2;
     return Q;
   }
   public double Bspline(double []Q, int i, int K, double X)
   { if(K == 1)
     { if     ( X < Q[i - 1]) return 0;
       else if( X < Q[i    ]) return 1;
       else                   return 0;
     } 
     else
     { double B1 = Bspline(Q, i    , K - 1, X);
       double B2 = Bspline(Q, i + 1, K - 1, X);
       return  (X           - Q[i - 1]) * B1 / (Q[i + K - 2] - Q[i - 1]) +
               (Q[i + K - 1]- X       ) * B2 / (Q[i + K - 1] - Q[i    ]);
     }
   }
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  int IX1= (int)(X1*200)+100; int IY1= 300- (int)(Y1*200);
      int IX2= (int)(X2*200)+100; int IY2= 300- (int)(Y2*200);
      g.drawLine(IX1,IY1,IX2,IY2);
   }
   public void paint(Graphics g)
   { double []  Q = setData(6);
     double []  X = new double[121];
     double []  Y = new double[121];
    
     for(int i=0;i<=120; i++)            //            ̎1ύX
     {  X[i] = ((double) i)*0.01; Y[i] = Bspline(Q, 1, 4, X[i]);
     }
     g.setColor(new Color(0,0,255));
     for(int i=0;i<121;i += 10) drawLine(g,i*0.01, 0, i*0.01,1);
     for(double y=0 ; y<=1.0;y += 0.2) drawLine(g,0, y, 1.2,y);
     
     g.setColor(new Color(255,0,0));
     for(int i=1;i<121;i++) drawLine(g,X[i-1],Y[i-1],X[i],Y[i]);
     
   } 
   public static void main(String[] args)
   {  Frame w = new deBoor();
      w.setVisible(true);
   }
}
